import 'dart:async';

import 'package:flyinsonolite/consultation/liveconsultation/controllers/liveconsultationcontroller.dart';
import 'package:flyinsonolite/consultation/liveconsultation/models/liveconsultationstate.dart';

class LiveLoadingController {
  LiveConsultationController liveConsultationController;
  LiveConsultationState get state => liveConsultationController.state;
  Timer? _timer;

  LiveLoadingController(this.liveConsultationController);

  void startLoading() {
    state.isLoading.value = true;
    state.showRetryButton.value = false;
    _timer?.cancel();
    _timer = Timer(const Duration(seconds: 15), () {
      state.isLoading.value = false;
      state.showRetryButton.value = true;
      _timer?.cancel();
    });
  }

  void stopLoading() {
    state.isLoading.value = false;
    state.showRetryButton.value = false;
    _timer?.cancel();
  }

  void retry() {
    state.isLoading.value = true;
    state.showRetryButton.value = false;
    startLoading();
  }

  void showRetryButton() {
    state.isLoading.value = false;
    state.showRetryButton.value = true;
    _timer?.cancel();
  }
}
