import 'dart:ui';
import 'package:fis_jsonrpc/rpc.dart';
import 'package:fis_lib_media_rt/fis_lib_media_rt.dart';
import 'package:flyinsonolite/consultation/liveconsultation/models/whiteboardstructure.dart';
import 'package:flyinsonolite/consultation/records/models/liveconsultation.dart';
import 'package:flyinsonolite/consultation/liveconsultation/models/playchannelinfo.dart';
import 'package:get/get.dart';

class LiveConsultationState {
  Rx<LiveConsultation?> liveConsultation = Rx(null);

  ///会诊记录详情
  ConsultationDetailDTO? consultationDetail;

  ///时间 秒数
  RxInt seconds = RxInt(0);

  ///时间 分钟
  RxInt minute = RxInt(0);

  ///超声机加载转圈
  RxBool isLoading = true.obs;

  ///超声机重试
  RxBool showRetryButton = false.obs;

  //判断设备是超声机还是魔盒
  bool isUSDevice = false;

  ///待会诊的病人列表
  RxList<ConsultationPageDTO> waitInLineForConsultationPatients = RxList();

  Rx<ConsultationPageDTO?> selectedPatient = Rx(null);

  ///超声机信息
  VideoDeviceOutputInfo? desktopDeviceInfo;

  ///播放频道Map,key:userId
  RxMap<String, PlayChannelInfo> playChannels = RxMap({});

  ///超声机桌面频道
  Rx<IPlayChannel?> deviceDesktopChannel = Rx(null);

  ///超声机摄像头频道
  Rx<IPlayChannel?> deviceCameraChannel = Rx(null);

  /// 是否为合图模式
  RxBool isMergedMode = false.obs;

  /// 超声机主画面在总画面的总占比
  Rect mainViewRectInMergedMode = Rect.zero;

  /// 是否需要裁切超声机画面
  bool isNeedCropDeviceDesktop = false;

  ///是否在主区域显示扫查手法（是否切换超声画面和扫查手法）
  RxBool isSwitchCameraDevice = false.obs;

  ///是否显示扫查手法（最小化则不显示）
  RxBool isShowDeviceCamera = true.obs;

  /// 初始化白板数据
  RxList<String> initBoardDatas = RxList();

  /// 会诊详情
  Rx<PaintType> paintType = Rx(PaintType.curvedLine);

  /// vid 录制中等待状态
  RxBool isVidFileCapturing = false.obs;

  /// vid 录制中等待状态 [由录制引发的加载]
  RxBool isVidFileCapturingByRecording = false.obs;

  ///是否展示截图列表
  RxBool isShowCaptureImageList = false.obs;

  ///上传队列中的截图数量
  RxInt captureImageUploadingCount = 0.obs;

  /// 每轮次上传的截图总数量
  RxInt captureImageUploadOnceSum = 0.obs;

  /// 截图、录制的图片列表
  RxList<ConsultationFileDTO> captureImageList = RxList();

  Rx<DateTime> vidCapturerStartTime = Rx(DateTime.now());

  /// vid 录制器状态
  RxBool isVidCapturerRecording = false.obs;

  List<UserExtendDTO> selectedExpertList = [];
}
