class PointsUtil {
  static String compressPointsList(List<List<double>> points) {
    String result = '';
    for (List<double> point in points) {
      result +=
          point[0].toStringAsFixed(4).replaceAll('0.', '').padRight(4, '0') +
              point[1].toStringAsFixed(4).replaceAll('0.', '').padRight(4, '0');
    }
    return result;
  }

  static List<List<double>> decompressPointsList(String compressed) {
    List<List<double>> result = [];
    for (int i = 0; i < compressed.length; i += 8) {
      String xString = compressed.substring(i, i + 4);
      String yString = compressed.substring(i + 4, i + 8);
      double x = double.parse(xString) / 10000;
      double y = double.parse(yString) / 10000;
      result.add([x, y]);
    }
    return result;
  }
}
