import 'package:fis_i18n/i18n.dart';
import 'package:flutter/material.dart';
import 'package:flyinsonolite/consultation/liveconsultation/controllers/liveconsultationcontroller.dart';
import 'package:flyinsonolite/consultation/records/models/consultationmember.dart';
import 'package:flyinsonolite/controls/text/fistext.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';
import 'package:get/get.dart';

class PreviewMemberCallingStatus extends StatelessWidget {
  final ConsultationMember member;
  final controller = Get.find<LiveConsultationController>();
  PreviewMemberCallingStatus(this.member, {super.key});

  @override
  Widget build(BuildContext context) {
    return Obx(() {
      var consultationMember = controller
          .state.liveConsultation.value!.memberLiveDatas
          .firstWhereOrNull((element) => element.id == member.id);
      if (consultationMember == null) {
        return const SizedBox();
      }
      if ([
        MemberStatus.Accepted,
        MemberStatus.Joined,
      ].contains(consultationMember.status.value)) {
        return const SizedBox();
        //return MemberAudioOperates(
        //  RoomMember(
        //    member.id!,
        //    mute: member.mute,
        //    videoOpend: member.videoOpend,
        //  ),
        //  channelInfo: controller.state.playChannels[member.id],
        //  setAudioMute: controller.setAudioMute,
        //  setVideoOpend: controller.setVideoOpend,
        //  setMicrophone: controller.setMicrophone,
        //);
      } else if (consultationMember.status.value == MemberStatus.Calling) {
        return _cancelCallingView(member);
      } else {
        return _callAgainView(member);
      }
    });
  }

  //再次呼叫视图
  Widget _callAgainView(ConsultationMember member) {
    return MouseRegion(
      cursor: SystemMouseCursors.click,
      child: GestureDetector(
        //name: 'callAgain',
        onTap: () {
          controller.callAgain(member.id ?? '');
        },
        //businessParent: this,
        child: Row(
          mainAxisAlignment: MainAxisAlignment.start,
          children: [
            SizedBox(width: 5.s),
            FISText(
              i18nBook.realTimeConsultation.callAgain.t,
              //style: _previewMemberTextStyle,
            ),
            Icon(
              Icons.refresh,
              color: Colors.grey,
              size: 16.s,
            ),
          ],
        ),
      ),
    );
  }

  ///取消呼叫视图
  Widget _cancelCallingView(ConsultationMember member) {
    return MouseRegion(
      cursor: SystemMouseCursors.click,
      child: GestureDetector(
          onTap: () {
            controller.cancelCall(member.id ?? '');
          },
          //businessParent: this,
          //name: 'cancel calling',
          child: Row(
            children: [
              SizedBox(width: 5.s),
              FISText(
                i18nBook.realTimeConsultation.cancelCall.t,
                //style: _previewMemberTextStyle,
              ),
              Icon(
                Icons.close,
                color: Colors.white,
                size: 36.s,
              ),
            ],
          )),
    );
  }
}
