import 'package:fis_common/extensions/string.dart';
import 'package:fis_i18n/i18n.dart';
import 'package:flyinsonolite/consultation/records/controllers/applyconsultationcontroller.dart';
import 'package:flyinsonolite/controls/prompt.dart';
import 'package:flyinsonolite/localization/localization.dart';
import 'package:get/get.dart';

class ChooseScanPositionController extends GetxController {
  final _consulttationConstant = 'consultation';
  var newScanPosition = "".obs;
  Rx<List<String>> scanPositionList = Rx([]);
  Rx<List<String>> selectedScanPositionList = Rx([]);
  var applyConsultationController = Get.find<ApplyConsultationController>();
  void initialize() {
    scanPositionList.value =
        applyConsultationController.scanPositionList.toList();
    var selectedScanPositions = applyConsultationController
            .appointmentInformation.appointmentScanningPosition ??
        [];
    for (var selectedScanPosition in selectedScanPositions) {
      if (!scanPositionList.value.contains(selectedScanPosition)) {
        scanPositionList.value.insert(0, selectedScanPosition);
      }
    }
    selectedScanPositionList.value = selectedScanPositions;
  }

  void addCustomScanPosition() {
    if (newScanPosition.value.isNullOrWhiteSpace) {
      PromptBox.toast(i18nBook.realTimeConsultation.checkPartNotEmpty.t);
      return;
    }
    for (var existScanPosition in scanPositionList.value) {
      var value = getLanguageValues(_consulttationConstant, existScanPosition);
      if (value.isNotNullOrWhiteSpace &&
          value == newScanPosition.value.trim()) {
        PromptBox.toast(i18nBook.realTimeConsultation.validateUniquePart.t);
        return;
      }
    }
    scanPositionList.value.insert(0, newScanPosition.value.trim());
    selectedScanPositionList.value.insert(0, newScanPosition.value.trim());
    scanPositionList.refresh();
  }

  void confirm() {
    applyConsultationController.selectedScanPositionList.value =
        selectedScanPositionList.value;
    applyConsultationController.scanPositionTextEditingController.text =
        selectedScanPositionList.value
            .map((data) => getLanguageValues('consultation', data))
            .join(";");
    applyConsultationController.appointmentInformation
        .appointmentScanningPosition = selectedScanPositionList.value;
    Get.close(1);
  }
}
