import 'package:fis_jsonrpc/rpc.dart';

/// 预约信息对象
class AppointmentInformation {
  /// 会诊设备
  String? appointmentDevice;

  /// 会诊时间
  DateTime? appointmentTime;

  /// 扫查医生
  String? appointmentScanDoctor;

  /// 疾病名称
  String? appointmentDiseaseName;

  /// 检查部位
  List<String>? appointmentScanningPosition;

  /// 会诊机构
  String? appointmentConsultationInstitution;

  /// 主管专家
  String? appointmentCompetentExperts;

  /// 申请人
  String? appointmentApplicant;

  /// 初步诊断
  String? preliminaryDiagnosis;

  AppointmentInformation({
    this.appointmentDevice,
    this.appointmentTime,
    this.appointmentScanDoctor,
    this.appointmentDiseaseName,
    this.appointmentScanningPosition,
    this.appointmentConsultationInstitution,
    this.appointmentCompetentExperts,
    this.appointmentApplicant,
    this.preliminaryDiagnosis,
  });
}

class ApproveConsultationInfo {
  String? consultationCode;
  DateTime? startTime;
  DateTime? endTime;
  String? competentExperts; //主管专家编码
  String? description; //会诊描述
  List<ConsultationReminderDTO>? consultationReminders; //提醒时间和提醒方式

  ///所有已选择的参与人员
  List<String> participants = [];
}
