import 'package:fis_i18n/i18n.dart';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';

///TimeOfDay转换为字符串
String transformFromTimeOfDay(TimeOfDay timeOfDay) {
  String time = timeOfDay.toString().split("(")[1].split(")")[0];
  return time;
}

///字符串转换为TimeOfDay
TimeOfDay transformFromString(String str) {
  TimeOfDay timeOfDay = TimeOfDay(
      hour: int.parse(str.split(":")[0]), minute: int.parse(str.split(":")[1]));
  return timeOfDay;
}

/// 另一种格式化时间段例如：
/// ZH：2023-12-12 12:00 - 13:00
/// EN：2023-12-12 12:00 - 13:00
String formatDateRangeWithYear(DateTime? start, DateTime? end,
    {bool simpleFormat = false}) {
  if (start == null || end == null) {
    return i18nBook.calendar.allDay.t;
  }

  if (simpleFormat) {
    return DateFormat('MM-dd HH:mm').format(start);
  }

  if (isSameDay(start, end)) {
    return '${DateFormat('yyyy-MM-dd HH:mm').format(start)} - ${DateFormat('HH:mm').format(end)}';
  } else {
    return '${DateFormat('yyyy-MM-dd HH:mm').format(start)} - ${DateFormat('yyyy-MM-dd HH:mm').format(end)}';
  }
}

/// 判定是否在同一天
bool isSameDay(DateTime? date1, DateTime? date2) {
  if (date1 == null || date2 == null) {
    return false;
  }
  return date1.year == date2.year &&
      date1.month == date2.month &&
      date1.day == date2.day;
}
