class PatientModel {
  final String key;
  final String type;
  final String showType;
  final bool required;
  final String desc;
  String? defaultValue;

  /// 数据是dynamic格式的
  final List<dynamic>? source;

  PatientModel({
    required this.key,
    required this.type,
    required this.showType,
    required this.required,
    required this.desc,
    this.defaultValue = '',
    this.source,
  });

  factory PatientModel.fromJson(Map<String, dynamic> json, String key) {
    return PatientModel(
        key: key,
        type: json['Type'],
        showType: json['ShowType'],
        required: json['Required'],
        desc: json['Desc'],
        source: json['Source'],
        defaultValue: json['DefaultValue']);
  }
}

class AppointmentModel {
  final String key;
  final bool isDefault;
  final bool required;
  final bool? isShow;
  AppointmentModel({
    required this.key,
    required this.isDefault,
    required this.required,
    this.isShow = true,
  });

  factory AppointmentModel.fromJson(Map<String, dynamic> json, String key) {
    return AppointmentModel(
      key: key,
      isDefault: json['IsDefult'],
      required: json['Required'],
      isShow: json['IsShow'],
    );
  }
}
