import 'package:fis_i18n/i18n.dart';
import 'package:flutter/material.dart';
import 'package:flyinsonolite/consultation/records/controllers/consultationdetailcontroller.dart';
import 'package:flyinsonolite/controls/dialog/fisdialog.dart';
import 'package:flyinsonolite/controls/text/fislabelinputfield.dart';
import 'package:flyinsonolite/controls/text/fistextfield.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';
import 'package:flyinsonolite/infrastructure/storage.dart';
import 'package:get/get.dart';

class RefuseConsultationDialog extends StatelessWidget {
  bool isThirdParty = false;
  RefuseConsultationDialog({super.key, this.isThirdParty = false});
  @override
  Widget build(BuildContext context) {
    var reason = "";
    return LayoutBuilder(
        builder: (BuildContext context, BoxConstraints constraints) {
      return FISDialog(
        isThirdParty
            ? i18nBook.realTimeConsultation.declineInvitation.t
            : i18nBook.realTimeConsultation.rejectApplication.t,
        FISLabelInputField(
            true,
            i18nBook.realTimeConsultation.reasonsForRefusal.t,
            FISTextField(
                uniqueKey: GlobalKey(),
                borderColor: Storage
                    .currentTheme.fisLabelInputFieldStyle.inputTextBorderColor,
                enabledBorderColor: Storage
                    .currentTheme.fisLabelInputFieldStyle.inputTextBorderColor,
                controller: TextEditingController(),
                onChanged: (value) {
                  reason = value;
                },
                maxLines: 6,
                contentPadding: EdgeInsets.all(10.s)),
            600.s,
            height: 150.s,
            labelColor:
                Storage.currentTheme.dialogStyle.messageTextStyle.color),
        true,
        true,
        onConfirm: () async {
          var controller = Get.find<ConsultationDetailController>();
          await controller.refuseConsultationAsync(reason, isThirdParty);
        },
      );
    });
  }
}
