import 'package:flyinsonolite/consultation/reports/pdf/pdfelement.dart';
import 'package:flyinsonolite/consultation/reports/reportinfo/block_element_info_interface.dart';
import 'package:pdf/widgets.dart' as pw;

abstract class PDFContainer extends PdfElement {
  PDFContainer(this.elementList);
  final List<IBlockElementInfo> elementList;

  pw.Widget _createElements() {
    var childrens = <pw.Widget>[];
    for (var element in elementList) {
      var ouputWidget = generateElementByBlockInfo(element);

      childrens.add(ouputWidget);
    }
    return pw.Column(
        mainAxisAlignment: pw.MainAxisAlignment.start, children: childrens);
  }

  @override
  pw.Widget generatePDFElement() {
    return pw.Container(child: _createElements());
  }

  List<pw.Widget> generatedPDFElements() {
    var childrens = <pw.Widget>[];
    for (var element in elementList) {
      var ouputWidget = generateElementByBlockInfo(element);

      childrens.add(ouputWidget);
    }

    return childrens;
  }
}
