import 'package:flyinsonolite/helpers/reportstylehelper.dart';
import 'package:flyinsonolite/consultation/reports/pdf/pdfelement.dart';
import 'package:flyinsonolite/consultation/reports/reportinfo/input_text_info.dart';
import 'package:flyinsonolite/consultation/reports/reportinfo/paragraph_info.dart';
import 'package:pdf/widgets.dart' as pw;

class PdfParagraph extends PdfElement {
  PdfParagraph(this.paragraphInfo);
  ParagraphInfo paragraphInfo;

  @override
  pw.Widget generatePDFElement({bool isParentRTCell = false}) {
    var childs = <pw.Widget>[];

    for (var olo in paragraphInfo.elementInfos!) {
      if (paragraphInfo.elementInfos!.length == 1) {
        if (_hasInputText()) {
          return generateElementByElementType(olo,
              parentElementHasNoContainer: true,
              parentIsTable: _parentIsGrid(),
              parentIsRTCell: isParentRTCell);
        }
        if (_parentIsGrid()) {
          return generateElementByElementType(
            olo,
            parentElementHasNoContainer: _hasInputText(),
            parentIsTable: true,
            parentIsRTCell: isParentRTCell,
          );
        }
      }

      childs.add(
          generateElementByElementType(olo, parentIsRTCell: isParentRTCell));
    }

    var elementHorizontalAlignment =
        paragraphInfo.element?.horizontalAlignment!;
    var elementVerticalAlignment = paragraphInfo.element?.verticalAlignment!;

    return pw.Wrap(
      children: childs,
      crossAxisAlignment:
          ReportStyleHelper.getWrapCrossAlignment(elementVerticalAlignment!),
      alignment:
          ReportStyleHelper.getWrapAlignment(elementHorizontalAlignment!),
    );
  }

  bool _hasInputText() {
    for (var e in paragraphInfo.elementInfos!) {
      if (e is InputTextInfo && paragraphInfo.parent == null) {
        return true;
      }
    }
    return false;
  }

  bool _parentIsGrid() {
    if (paragraphInfo.element == null) {
      return false;
    }
    if (paragraphInfo.element!.parent == null) {
      return true;
    }

    return false;
  }
}
