import 'package:flyinsonolite/consultation/reports/reporttemplate/element_tag.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/element_type.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/interfaces/element.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/interfaces/report_element.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/measure_tag.dart';

abstract class ElementInfo {
  ElementInfo();

  ElementType? elementType;

  int? index;

  MeasureTag? measureTag;

  IReportElement? parent;

  ElementTag? tag;

  String? id;

  IElement? element;

  ElementInfo.fromElement(this.element) {
    elementType = element?.elementType;
    index = element?.index;
    measureTag = element?.measureTag;
    parent = element?.parent;
    tag = element?.tag;
    id = element?.id;
  }

  Map<String, dynamic> toJson() => {
        'Index': index,
        'Id': id,
        'ElementType': elementType!.toJson(),
        'MeasureTag': measureTag == null ? null : measureTag!.toJson(),
      };
}
