import 'package:flyinsonolite/consultation/reports/reportinfo/block_element_info_interface.dart';
import 'package:flyinsonolite/consultation/reports/reportinfo/element_info.dart';
import 'package:flyinsonolite/consultation/reports/reportinfo/rt_grid.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/rt_table.dart';

class RTTableInfo extends RTGridInfo implements IBlockElementInfo {
  bool? autoHide;
  bool? isAverageColumnWidth;
  bool? allowBreakAcrossPages;

  @override
  List<ElementInfo>? elementInfos;

  RTTableInfo() : super();

  RTTableInfo.fromElement(RTTable table) : super.fromElement(table) {
    autoHide = table.autoHide;
    isAverageColumnWidth = table.isAverageColumnWidth;
    allowBreakAcrossPages = table.allowBreakAcrossPages;
  }

  @override
  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map.addAll(super.toJson());
    return map;
  }

  /// 深拷贝方法
  RTTableInfo clone() {
    final tableInfo = RTTableInfo();
    tableInfo.elementType = elementType;
    tableInfo.index = index;
    tableInfo.measureTag = measureTag;
    tableInfo.parent = parent;
    tableInfo.tag = tag;
    tableInfo.id = id;
    tableInfo.element = element;
    tableInfo.columnDefinitions = columnDefinitions;
    tableInfo.rowDefinitions = rowDefinitions;
    tableInfo.isDelete = isDelete;
    tableInfo.isInsertColumn = isInsertColumn;
    tableInfo.deleteRowIndex = deleteRowIndex;
    tableInfo.deleteColumnIndex = deleteColumnIndex;
    tableInfo.isMergeCell = isMergeCell;
    tableInfo.mergeDeleteStartColumnIndex = mergeDeleteStartColumnIndex;
    tableInfo.mergeDeleteEndColumnIndex = mergeDeleteEndColumnIndex;
    tableInfo.cells = cells;
    tableInfo.autoHide = autoHide;
    tableInfo.isAverageColumnWidth = isAverageColumnWidth;
    tableInfo.allowBreakAcrossPages = allowBreakAcrossPages;
    tableInfo.elementInfos = elementInfos;
    return tableInfo;
  }
}
