import 'package:flyinsonolite/consultation/reports/reporttemplate/interfaces/date_time_element.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/text_element.dart';

class DateTimeElement extends TextElement implements IDateTimeElement {
  @override
  String? dateTimeFormat = 'yyyy-MM-dd';

  @override
  bool isReadOnly = false;

  @override
  bool isRealTime = true;

  @override
  bool? showEnabled = false;

  DateTimeElement.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    dateTimeFormat = json['DateTimeFormat'];
    isReadOnly = json['IsReadOnly'] ?? false;
    isRealTime = json['IsRealTime'];
    showEnabled = json['ShowEnabled'];
    if (lineWidth == 0) {
      lineWidth = 90.91;
    }
  }
}
