import 'package:flyinsonolite/converters/intodoubleconverter.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/inline_element.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/interfaces/text_element.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/rt_color.dart';

abstract class TextElement extends InlineElement implements ITextElement {
  @override
  String? fontName;
  @override
  double? fontSize;
  @override
  List<RTFontStyle>? fontStyles = [];
  @override
  RTColor? fontColor;
  @override
  RTColor? background;
  @override
  int? lineLength;
  @override
  double? lineWidth;

  ///是否自动换行
  @override
  bool? textWrap;

  ///from json
  TextElement.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    fontName = json['FontName'];
    fontSize = IntToDouble.intToDouble(json['FontSize']);
    List<dynamic> jsonStyles = json['FontStyles'];
    if (jsonStyles.isNotEmpty) {
      for (var s in jsonStyles) {
        fontStyles!
            .add(RTFontStyle.values.firstWhere((element) => element.name == s));
      }
    }
    fontColor = RTColor.fromJson(json['FontColor']);
    background = RTColor.fromJson(json['Background']);
    lineLength = json['LineLength'];
    lineWidth = IntToDouble.intToDouble(json['LineWidth']);
    textWrap = json['TextWrap'];
  }
}
