import 'package:fis_common/extensions/index.dart';
import 'package:fis_jsonrpc/rpc.dart';
import 'package:flutter/material.dart';
import 'package:flyinsonolite/consultation/records/controllers/consultationdetailcontroller.dart';
import 'package:flyinsonolite/controls/button/fisiconbutton.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';
import 'package:get/get.dart';

class ConsultationReportPreviewPage
    extends GetView<ConsultationDetailController> {
  final ScrollController _scrollController = ScrollController();
  ReportDTO reportDTO;
  List<String> reportImageList = [];
  ConsultationReportPreviewPage(this.reportDTO, {super.key});

  @override
  Widget build(BuildContext context) {
    var images = reportDTO.reportPreviewList
            ?.where((element) => element.fileType == UploadFileTypeEnum.JPG) ??
        [];
    var imageList = images.map((e) => e.fileToken ?? '').toList();
    for (var image in imageList) {
      if (image.contains(';')) {
        reportImageList
            .addAll(image.split(';').where((element) => element.isNotEmpty));
      } else {
        reportImageList.add(image);
      }
    }

    return Container(
      color: Colors.black,
      child: SafeArea(
        child: Container(
          margin: EdgeInsets.all(5.s),
          child: Stack(
            children: [
              ScrollConfiguration(
                behavior:
                    ScrollConfiguration.of(context).copyWith(scrollbars: false),
                child: ListView.separated(
                    shrinkWrap: true,
                    controller: _scrollController,
                    itemCount: reportImageList.length,
                    itemBuilder: (BuildContext context, int index) {
                      return buildreportpaper(index);
                    },
                    separatorBuilder: (context, index) {
                      return SizedBox(
                        height: 5.s,
                      );
                    }),
              ),
              _buildCloseIconButton(),
            ],
          ),
        ),
      ),
    );
  }

  ///关闭Icon按钮
  Widget _buildCloseIconButton() {
    return Positioned(
        right: 0,
        top: 0,
        child: FISIconButton(
          onPressed: () {
            Get.close(1);
          },
          icon: const Icon(
            Icons.close,
          ),
          iconSize: 56.s,
          padding: EdgeInsets.only(top: 10.s),
        ));
  }

  Widget buildreportpaper(int index) {
    var fileToken = reportImageList[index];
    if (fileToken.isNullOrWhiteSpace) {
      return Center(
          child: SizedBox(
        width: 709.2.s,
        height: 1000.s,
      ));
    } else {
      return Center(
          child: Image.network(
        fileToken,
        fit: BoxFit.contain,
        width: 709.2.s,
        height: 1000.s,
      ));
    }
  }
}
