import 'package:fis_i18n/i18n.dart';
import 'package:fis_jsonrpc/services/report.m.dart';
import 'package:flutter/material.dart';
import 'package:flyinsonolite/controls/dialog/fisdialog.dart';
import 'package:flyinsonolite/controls/qrcode/qrcodeimageview.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';
import 'package:flyinsonolite/jsonrpc/jsonrpcclient.dart';
import 'package:flyinsonolite/infrastructure/storage.dart';
import 'package:get/get.dart';

class QRCodeShareDialog extends GetView<QRCodeShareController> {
  final String reportCode;
  const QRCodeShareDialog(this.reportCode, {super.key});

  @override
  Widget build(BuildContext context) {
    Get.put<QRCodeShareController>(QRCodeShareController());
    return FutureBuilder(
        future: controller.gertQRCodeAsync(reportCode),
        builder: (context, snapshot) {
          if (snapshot.connectionState == ConnectionState.done) {
            return LayoutBuilder(builder: (context, constraint) {
              return FISDialog(i18nBook.remedical.share.t, _createContentView(),
                  false, false);
            });
          } else {
            return const SizedBox();
          }
        });
  }

  Widget _createContentView() {
    return Container(
      width: 300.s,
      height: 300.s,
      color: Colors.white,
      padding: EdgeInsets.all(10.s),
      child: Obx(() => QrImageView(
            data: "${controller.qrCode.value}&",
            size: 280.s,
          )),
    );
  }
}

class QRCodeShareController extends GetxController {
  final RxString qrCode = "".obs;

  Future gertQRCodeAsync(String reportCode) async {
    FindReportShareUrlRequest request = FindReportShareUrlRequest(
        token: Storage.user.token, reportCode: reportCode);
    qrCode.value = await jsonRpcProxy.report.findReportShareUrlAsync(request);
  }
}
