import 'package:flutter/material.dart';
import 'package:flyinsonolite/consultation/reports/widgets/input_imageList.dart';
import 'package:flyinsonolite/consultation/reports/widgets/paragraphview.dart';
import 'package:flyinsonolite/consultation/reports/widgets/rttableview.dart';
import 'package:flyinsonolite/consultation/reports/widgets/testboxdecoration.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/element_type.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/input_image_list.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/interfaces/block_element.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/paragraph.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/rt_table.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';

class FBlockElementPage extends StatefulWidget {
  const FBlockElementPage({required this.element, Key? key}) : super(key: key);

  final IBlockElement element;

  @override
  State<StatefulWidget> createState() {
    return _BlockElementState();
  }
}

class _BlockElementState extends State<FBlockElementPage> {
  ElementType get _type => widget.element.elementType!;
  @override
  initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    if (_type.name == ElementType.rtTable.name) {
      RTTable t = widget.element as RTTable;
      return FRTTablePage(element: t);
    } else if (_type.name == ElementType.paragraph.name) {
      final paragraph = widget.element as Paragraph;
      return FParagraphPage(paragraph: paragraph);
    } else if (_type.name == ElementType.imageList.name) {
      final inputImageList = widget.element as InputImageList;
      return Center(
        child: FInputImageList(inputImageList, null),
      );
    }
    return Container(
      height: 20.s,
      decoration: TestBoxDecoration.buildDecoration(),
    );
  }
}
