import 'package:flutter/material.dart';
import 'package:flyinsonolite/converters/pttopxconverter.dart';
import 'package:flyinsonolite/consultation/reports/widgets/myseparator.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/line.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/rt_border.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/rt_thickness.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';

class FLine extends StatefulWidget {
  final Line line;

  const FLine(this.line, {Key? key}) : super(key: key);

  @override
  State<StatefulWidget> createState() {
    return _LineState();
  }
}

class _LineState extends State<FLine> {
  _LineState();

  @override
  initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    final borderStyle = widget.line.borderStyle;
    final stroke = widget.line.stroke!;
    final a = stroke.a!;
    final r = stroke.r!;
    final g = stroke.g!;
    final b = stroke.b!;
    final margin = widget.line.margin ?? RTThickness.uniform(0);
    return Container(
      height: 10.s,
      alignment: Alignment.center,
      margin: EdgeInsets.only(
          top: margin.top!.s,
          bottom: margin.bottom!.s,
          right: margin.right!.s,
          left: margin.left!.s),
      width: PtToPxConverter.ptToPx(widget.line.width),
      child: borderStyle == RTBorderStyle.Solid
          ? Divider(
              height: widget.line.thickness != null
                  ? widget.line.thickness!.s
                  : widget.line.thickness,
              thickness: widget.line.thickness != null
                  ? widget.line.thickness!.s
                  : widget.line.thickness,
              color: Color.fromARGB(a, r, g, b),
            )
          : MySeparator(
              borderStyle: borderStyle ?? RTBorderStyle.Dash,
              height: 1.s,
            ),
    );
  }
}
