import 'package:flutter/cupertino.dart';
import 'package:flyinsonolite/consultation/reports/widgets/foptionrow.dart';
import 'package:flyinsonolite/consultation/reports/reportinfo/multi_selected_vertical_info.dart';
import 'package:flyinsonolite/consultation/reports/reportinfo/report_info.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/multi_selected_vertical.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';

class FMultiSelectedVertical extends StatefulWidget {
  final MultiSelectedVertical multiSelected;

  const FMultiSelectedVertical(this.multiSelected, {Key? key})
      : super(key: key);

  @override
  State<StatefulWidget> createState() {
    return _RRMultiSelectedVerticalState();
  }
}

class _RRMultiSelectedVerticalState extends State<FMultiSelectedVertical> {
  List<String> _selectedItems = [];
  MulitiSelectedVerticalInfo? _mulitiSelectedInfo;
  @override
  Widget build(BuildContext context) {
    _initDatas();
    return Column(
      children: [
        ...widget.multiSelected.items!.map((e) => FOptionRow(
              widget.multiSelected,
              e,
              isActive: true,
              height: 22.s,
              onTap: () {
                if (mounted) {
                  setState(() {
                    _onSelectedItem(e);
                  });
                }
              },
              isSelected: _selectedItems.contains(e),
            ))
      ],
    );
  }

  void _onSelectedChangeCallback(Object sender, List<String> e) {
    if (mounted) {
      setState(() {
        _selectedItems = e;
      });
    }
  }

  void _initDatas() {
    final multiSelected = widget.multiSelected;
    final selectInfo = FReportInfo.instance.getElementInfo(multiSelected);
    if (selectInfo != null && _mulitiSelectedInfo != selectInfo) {
      _mulitiSelectedInfo = selectInfo as MulitiSelectedVerticalInfo;
      _mulitiSelectedInfo!.onSelectedChange
          .removeListener(_onSelectedChangeCallback);
      _mulitiSelectedInfo!.onSelectedChange
          .addListener(_onSelectedChangeCallback);
    }
    if (multiSelected.items!.isNotEmpty) {}
    if (_mulitiSelectedInfo!.selectedItems != _selectedItems) {
      _selectedItems = _mulitiSelectedInfo!.selectedItems;
    }
  }

  _onSelectedItem(String value) {
    if (_selectedItems.contains(value)) {
      _selectedItems.remove(value);
    } else {
      _selectedItems.add(value);
    }
    if (_mulitiSelectedInfo != null) {
      _mulitiSelectedInfo!.selectedItems = _selectedItems;
    }
  }
}
