import 'package:flutter/material.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/rt_border.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';

class MySeparator extends StatelessWidget {
  final double height;
  final RTBorderStyle borderStyle;
  final Color color;

  const MySeparator(
      {required this.height,
      this.borderStyle = RTBorderStyle.Dash,
      this.color = Colors.black,
      Key? key})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    double dashWidth = 4.s;
    switch (borderStyle) {
      case RTBorderStyle.None:
        break;
      case RTBorderStyle.Solid:
        break;
      case RTBorderStyle.Dash:
        dashWidth = 3.s;
        break;
      case RTBorderStyle.Dot:
        dashWidth = 1.s;
        break;
      case RTBorderStyle.DashDot:
        break;
      case RTBorderStyle.DashDotDot:
        break;
      case RTBorderStyle.Double:
        break;
    }
    return LayoutBuilder(
      builder: (BuildContext context, BoxConstraints constraints) {
        final boxWidth = constraints.constrainWidth();
        final dashHeight = height;
        final dashCount = (boxWidth / (2 * dashWidth)).floor();
        return Flex(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          direction: Axis.horizontal,
          children: List.generate(dashCount, (_) {
            return SizedBox(
              width: dashWidth,
              height: dashHeight,
              child: DecoratedBox(
                decoration: BoxDecoration(color: color),
              ),
            );
          }),
        );
      },
    );
  }
}
