import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flyinsonolite/consultation/reports/widgets/input_imageList.dart';
import 'package:flyinsonolite/consultation/reports/widgets/paragraphview.dart';
import 'package:flyinsonolite/consultation/reports/widgets/rttableview.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/cell_postion.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/element_type.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/input_image_list.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/interfaces/block_element.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/paragraph.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/rt_Cell.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/rt_table.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';

class FRTCellPage extends StatefulWidget {
  final double? width;
  final CellPostion? cellPostion;
  final String parentTableId;
  const FRTCellPage(
      {required this.cell,
      this.width,
      this.cellPostion,
      this.parentTableId = "",
      Key? key})
      : super(key: key);

  final RTCell cell;

  @override
  State<StatefulWidget> createState() {
    return _RTCellState();
  }
}

class _RTCellState extends State<FRTCellPage> {
  List<IBlockElement> get _blocks => widget.cell.blocks ?? [];

  @override
  initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return _blocks.isEmpty
        ? Container(
            constraints: BoxConstraints(minHeight: 24.s),
            width: widget.width,
          )
        : Wrap(
            alignment: WrapAlignment.center,
            runAlignment: WrapAlignment.center,
            runSpacing: 2.s,
            children: [
              ..._blocks.map((e) {
                if (e.elementType!.name == ElementType.paragraph.name) {
                  final paragraph = e as Paragraph;
                  return Container(
                    width: widget.width,
                    alignment: Alignment.center,
                    child: FParagraphPage(
                      paragraph: paragraph,
                      cellPostion: widget.cellPostion,
                      parentTableId: widget.parentTableId,
                    ),
                  );
                } else if (e.elementType!.name == ElementType.rtTable.name) {
                  final table = e as RTTable;
                  return SizedBox(
                    width: widget.width,
                    child: FRTTablePage(element: table),
                  );
                } else if (e.elementType!.name == ElementType.imageList.name) {
                  final inputImageList = e as InputImageList;
                  return Center(
                    child: FInputImageList(inputImageList, widget.cellPostion,
                        parentTableId: widget.parentTableId),
                  );
                }
                return Container();
              }),
            ],
          );
  }
}
