import 'dart:convert' as convert;

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flyinsonolite/converters/alignmentconverter.dart';
import 'package:flyinsonolite/converters/marginconverter.dart';
import 'package:flyinsonolite/converters/pttopxconverter.dart';
import 'package:flyinsonolite/consultation/reports/reporttemplate/static_image.dart';

class FStaticImage extends StatefulWidget {
  final StaticImage staticImage;

  const FStaticImage(this.staticImage, {Key? key}) : super(key: key);
  @override
  State<StatefulWidget> createState() {
    return _FStaticImageState();
  }
}

class _FStaticImageState extends State<FStaticImage> {
  _FStaticImageState();

  @override
  initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    final bytes = convert.base64Decode(widget.staticImage.source!);
    return Container(
      height: PtToPxConverter.ptToPx(widget.staticImage.imageHeight),
      width: PtToPxConverter.ptToPx(widget.staticImage.imageWidth),
      alignment: AlignmentConverter.horizontalConvert(
          widget.staticImage.horizontalAlignment),
      margin: MarginConverter.marginConvert(widget.staticImage.margin),
      child: Image.memory(
        bytes,
        fit: BoxFit.fill,
      ),
    );
  }
}
