import 'package:flutter/material.dart';
import 'package:flyinsonolite/controls/button/fislineargradientelevatedbutton.dart';
import 'package:flyinsonolite/controls/custom/customelevatedbutton.dart';
import 'package:flyinsonolite/controls/text/fistext.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';
import 'package:flyinsonolite/infrastructure/storage.dart';

class FISElevatedButton extends StatelessWidget {
  double? width;
  double? height;
  bool _isBusy = false;
  final VoidCallback? onPressed;
  final ButtonStyle? buttonStyle;
  String text;
  TextStyle? textStyle;
  FISElevatedButton(this.onPressed, this.text,
      {super.key, this.buttonStyle, this.width, this.height, this.textStyle});

  @override
  Widget build(BuildContext context) {
    return Container(
        width: width,
        height: height,
        decoration: BoxDecoration(borderRadius: BorderRadius.circular(4.s)),
        child: CustomElevatedButton(
          onPressed: () {
            if (_isBusy) {
              return;
            }
            try {
              _isBusy = true;
              if (onPressed != null) {
                onPressed!();
              }
            } finally {
              _isBusy = false;
            }
          },
          style: buttonStyle,
          child: FISText(
            text,
            style: textStyle ??
                Storage.currentTheme.normalTextStyle.copyWith(
                    color: Storage.currentTheme
                        .elevatedButtonLinearGradientStyle.textColor,
                    fontSize: Storage.currentTheme.normalTextStyle.fontSize!.s),
          ),
        ));
  }
}

class FISElevatedButtonAsync extends StatelessWidget {
  double? width;
  double? height;
  bool _isBusy = false;
  final AsyncVoidCallback? onPressed;
  final ButtonStyle? buttonStyle;
  String text;
  TextStyle? textStyle;
  FISElevatedButtonAsync(this.onPressed, this.text,
      {super.key, this.buttonStyle, this.width, this.height, this.textStyle});

  @override
  Widget build(BuildContext context) {
    return Container(
        width: width,
        height: height,
        decoration: BoxDecoration(borderRadius: BorderRadius.circular(4.s)),
        child: CustomElevatedButton(
          onPressed: () async {
            if (_isBusy) {
              return;
            }
            try {
              _isBusy = true;
              if (onPressed != null) {
                await onPressed!();
              }
            } finally {
              _isBusy = false;
            }
          },
          style: buttonStyle,
          child: FISText(
            text,
            style: textStyle ??
                Storage.currentTheme.normalTextStyle.copyWith(
                    color: Storage.currentTheme
                        .elevatedButtonLinearGradientStyle.textColor,
                    fontSize: Storage.currentTheme.normalTextStyle.fontSize!.s),
          ),
        ));
  }
}
