import 'package:flutter/material.dart';
import 'package:flyinsonolite/controls/custom/customcheckbox.dart';
import 'package:flyinsonolite/controls/text/fistext.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';
import 'package:flyinsonolite/infrastructure/storage.dart';

class FISCheckBox extends StatelessWidget {
  String? label;
  TextStyle? labelTextSty;
  bool? value;
  final ValueChanged<bool?>? onChanged;

  FISCheckBox(this.value, this.onChanged,
      {super.key, this.label, this.labelTextSty});
  @override
  Widget build(BuildContext context) {
    return InkWell(
      onTap: () {
        onChanged!(value! ? false : true);
      },
      child: Row(
        children: [
          CustomCheckbox(
            value: value,
            onChanged: onChanged,
            fillColor: MaterialStateColor.resolveWith((states) {
              if (states.contains(MaterialState.selected)) {
                return Colors.blue; // 选中状态的填充色
              }
              return Storage.currentTheme.normalTextStyle.color!; // 默认状态的填充色
            }),
          ),
          SizedBox(
            width: 5.s,
          ),
          label == null
              ? const SizedBox()
              : FISText(
                  label!,
                  style: labelTextSty,
                ),
        ],
      ),
    );
  }
}
