import 'package:flutter/material.dart';
import 'package:flyinsonolite/controls/custom/customdropdownbutton.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';
import 'package:flyinsonolite/infrastructure/storage.dart';

class FISDropdownButton extends CustomDropdownButton {
  FISDropdownButton(
      {super.key,
      required super.items,
      super.value,
      required super.onChanged,
      Widget? underline,
      Color? dropdownColor,
      Widget? disabledHint,
      TextStyle? textStyle})
      : super(
          style: textStyle ??
              Storage.currentTheme.normalTextStyle.copyWith(
                  fontSize: Storage.currentTheme.normalTextStyle.fontSize!.s),
          dropdownColor: dropdownColor ??
              Storage.currentTheme.dropdownButtonStyle.dropdownColor,
          elevation: 8,
          iconSize: 24.s,
          itemHeight: kMinInteractiveDimension.s,
          isExpanded: true,
          iconEnabledColor: Storage.currentTheme.dropdownButtonStyle.iconColor,
          disabledHint: disabledHint,
          underline: underline ??
              Container(
                height: 3.s,
                color: Storage.currentTheme.dropdownButtonStyle.iconColor,
              ),
        );
}
