import 'package:flutter/material.dart';
import 'package:flyinsonolite/controls/custom/customdropdownbutton.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';
import 'package:flyinsonolite/infrastructure/storage.dart';

class FISSelect<T> extends StatelessWidget {
  final List<CustomDropdownMenuItem<T>>? items;
  final T? value;
  final ValueChanged<T?>? onChanged;
  final Color? backgroundColor;
  final Color borderColor;
  final double? width;

  const FISSelect(this.items, this.onChanged,
      {super.key,
      this.width,
      this.backgroundColor,
      this.value,
      this.borderColor = const Color(0xFF000000)});

  @override
  Widget build(BuildContext context) {
    return Container(
      width: width,
      padding: EdgeInsets.fromLTRB(5.s, 0, 0, 0),
      decoration: BoxDecoration(
          color: backgroundColor,
          borderRadius: BorderRadius.circular(4.s),
          border: Border.all(color: borderColor, width: 1.s)),
      child: CustomDropdownButtonHideUnderline(
          child: CustomDropdownButton(
        itemHeight: kMinInteractiveDimension.s,
        items: items,
        onChanged: onChanged,
        iconSize: 24.s,
        value: value,
        menuMaxHeight: 600.s,
      )),
    );
  }
}
