import 'package:flutter/cupertino.dart';
import 'package:flyinsonolite/infrastructure/scale.dart';
import 'package:flyinsonolite/infrastructure/storage.dart';

class FISText extends StatelessWidget {
  final String data;
  final TextStyle? style;
  final TextAlign? textAlign;
  final bool? softWrap;
  final TextOverflow? overflow;
  final int? maxLines;
  const FISText(this.data,
      {this.style,
      this.textAlign,
      this.softWrap,
      this.overflow,
      this.maxLines,
      key});

  @override
  Widget build(BuildContext context) {
    return Text(
      data,
      style: style ??
          Storage.currentTheme.normalTextStyle.copyWith(
              fontSize: Storage.currentTheme.normalTextStyle.fontSize!.s),
      textAlign: textAlign,
      softWrap: softWrap ?? false,
      overflow: overflow,
      maxLines: maxLines,
    );
  }
}
