import 'package:fis_i18n/i18n.dart';
import 'package:flyinsonolite/infrastructure/storage.dart';

class RouteConstants {
  /// 首页
  static const login = '/login/:language/:theme';

  ///首页带主题语言
  static String get loginWithThemeAndLanguage =>
      '/login/${i18nBook.locale.languageCode.toLowerCase()}/${Storage.currentTheme.themeName}';

  ///登录后的页面，显示预约会诊，即时会诊，下方病例等按钮
  static const home = '/home';

  static final consultationRouteConstants = ConsultationRouteConstants();
}

class ConsultationRouteConstants {
  final consultationList = "/consultationlist";
  final applyconsultation = "/applyconsultation";
  final liveconsultation = "/liveconsultation";
}
