import 'dart:ui';

import 'package:flyinsonolite/infrastructure/storage.dart';
import 'package:get/get.dart';

extension SizeExtension on num {
  //先根据设备像素比进行修正比例，保持在不同设备上，布局大小与Windows端一致
  double get s => Storage.isPortraitMode.value
      ? this *
          (Get.height > 1920 / window.devicePixelRatio
              ? Get.height / (1920 / window.devicePixelRatio)
              : 1) /
          window.devicePixelRatio
      : this *
          (Get.width > 1920 / window.devicePixelRatio
              ? Get.width / (1920 / window.devicePixelRatio)
              : 1) /
          window.devicePixelRatio;
}
