import 'dart:convert';
import 'dart:math';
import 'package:fis_common/extensions/index.dart';
import 'package:fis_jsonrpc/rpc.dart';
import 'package:flutter/material.dart';
import 'package:flyinsonolite/infrastructure/storage.dart';

ImageProvider<Object> buildUserAvatarProvider(String? headImgUrl,
    {bool isUS = false}) {
  var localUrl =
      isUS ? "assets/images/mock_terminal.png" : "assets/images/avatar_man.png";
  ImageProvider child;
  headImgUrl.isNullOrWhiteSpace
      ? child = AssetImage(localUrl)
      : child = NetworkImage(headImgUrl!);
  return child;
}

/// 是否移动端
///
/// iOS/Android 默认移动端
/// Windows 默认桌面端
bool get kIsMobile =>
    Storage.platform == Platform.Android || Storage.platform == Platform.Ios;

///获取输出高度
double getVideoDeviceInfoHeight(
    {VideoDeviceSourceTypeEnum videoDeviceSourceType =
        VideoDeviceSourceTypeEnum.Desktop,
    required List<VideoDeviceOutputInfo> videoDeviceInfos}) {
  var device = videoDeviceInfos.firstWhere(
      (element) => element.videoDeviceSourceType == videoDeviceSourceType);
  return device.outputHeight.toDouble();
}

///获取输出宽度
double getVideoDeviceInfoWidth(
    {VideoDeviceSourceTypeEnum videoDeviceSourceType =
        VideoDeviceSourceTypeEnum.Desktop,
    required List<VideoDeviceOutputInfo> videoDeviceInfos}) {
  var device = videoDeviceInfos.firstWhere(
      (element) => element.videoDeviceSourceType == videoDeviceSourceType);
  return device.outputWidth.toDouble();
}

String generateRandom([int length = 16]) {
  final Random random = Random.secure();
  var values = List<int>.generate(length, (i) => random.nextInt(256));
  return base64Url.encode(values).substring(0, length);
}

bool truthful(value) {
  if (value == null) {
    return false;
  }
  if (value == true ||
      value == 'true' ||
      value == 1 ||
      value == '1' ||
      value.toString().toLowerCase() == 'yes') {
    return true;
  }
  return false;
}
