import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'connection.m.dart';

class ConnectionService extends JsonRpcClientBase {
  ConnectionService(
    String host, {
    String serviceName = "IConnectionService",
    Map<String, String>? headers,
    int? timeout,
  }) : super(
          host,
          serviceName,
          headers: headers,
          timeout: timeout,
        ) {
    /// 注册响应实体反序列化处理器
    FJsonConvert.setDecoder((map) => FISUSMachineInfoForFlutter.fromJson(map));
  }

  Future<FISUSMachineInfoForFlutter> getUSMachineInfoForFlutter() async {
    var rpcRst = await call(
      "GetUSMachineInfoForFlutter",
    );
    var result =
        FISUSMachineInfoForFlutter.fromJson(rpcRst as Map<String, dynamic>);
    return result;
  }

  Future<void> hideFlyinsonoPageForFlutter() async {
    await call(
      "HideFlyinsonoPageForFlutter",
    );
  }

  Future<void> closeFlyinsonoPageForFlutter() async {
    await call(
      "CloseFlyinsonoPageForFlutter",
    );
  }
}
