enum FISPlatform {
  Windows,
  Android,
  Ios,
}

class FISUSMachineInfoForFlutter {
  String? serverUrl;
  bool useSSL;
  String? deviceCode;
  FISPlatform platform;
  bool isLogon;
  bool hasMultiScreens;
  String? fISVersion;
  bool isShowCloseButton;

  FISUSMachineInfoForFlutter({
    this.serverUrl,
    this.useSSL = false,
    this.deviceCode,
    this.platform = FISPlatform.Windows,
    this.isLogon = false,
    this.hasMultiScreens = false,
    this.fISVersion,
    this.isShowCloseButton = false,
  });

  factory FISUSMachineInfoForFlutter.fromJson(Map<String, dynamic> map) {
    return FISUSMachineInfoForFlutter(
      serverUrl: map['ServerUrl'],
      useSSL: map['UseSSL'],
      deviceCode: map['DeviceCode'],
      platform:
          FISPlatform.values.firstWhere((e) => e.index == map['Platform']),
      isLogon: map['IsLogon'],
      hasMultiScreens: map['HasMultiScreens'],
      fISVersion: map['FISVersion'],
      isShowCloseButton: map['IsShowCloseButton'],
    );
  }

  Map<String, dynamic> toJson() {
    final map = Map<String, dynamic>();
    if (serverUrl != null) {
      map['ServerUrl'] = serverUrl;
    }
    map['UseSSL'] = useSSL;
    if (deviceCode != null) {
      map['DeviceCode'] = deviceCode;
    }
    map['Platform'] = platform.index;
    map['IsLogon'] = isLogon;
    map['HasMultiScreens'] = hasMultiScreens;
    if (fISVersion != null) {
      map['FISVersion'] = fISVersion;
    }
    map['IsShowCloseButton'] = isShowCloseButton;
    return map;
  }
}
