import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';
import 'package:fis_common/json_convert.dart';

import 'log.m.dart';

class LogService extends JsonRpcClientBase {
  LogService(
    String host, {
    String serviceName = "ILogService",
    Map<String, String>? headers,
    int? timeout,
  }) : super(
          host,
          serviceName,
          headers: headers,
          timeout: timeout,
        ) {
    /// 注册响应实体反序列化处理器
    FJsonConvert.setDecoder((map) => FISResultInfoDTO.fromJson(map));
  }

  Future<FISResultInfoDTO> writeLogFromFlutter(
      FISLogEventArgs fisLogEventArgs) async {
    var rpcRst = await call("WriteLogFromFlutter", fisLogEventArgs);
    var result = FISResultInfoDTO.fromJson(rpcRst as Map<String, dynamic>);
    return result;
  }
}
