class FISResultInfoDTO {
  bool isSuccess;
  String? failMessage;
  int errorCode;

  FISResultInfoDTO({
    this.isSuccess = false,
    this.failMessage,
    this.errorCode = 0,
  });

  factory FISResultInfoDTO.fromJson(Map<String, dynamic> map) {
    return FISResultInfoDTO(
      isSuccess: map['IsSuccess'],
      failMessage: map['FailMessage'],
      errorCode: map['ErrorCode'],
    );
  }

  Map<String, dynamic> toJson() {
    final map = Map<String, dynamic>();
    map['IsSuccess'] = isSuccess;
    if (failMessage != null) {
      map['FailMessage'] = failMessage;
    }
    map['ErrorCode'] = errorCode;
    return map;
  }
}

enum FISDeviceLogCategory {
  placeHolder_0,
  Error,
  Warn,
  Info,
  Verb,
}

class FISLogEventArgs {
  FISDeviceLogCategory logType;
  String? msg;

  FISLogEventArgs({
    this.logType = FISDeviceLogCategory.Error,
    this.msg,
  });

  factory FISLogEventArgs.fromJson(Map<String, dynamic> map) {
    return FISLogEventArgs(
      logType: FISDeviceLogCategory.values
          .firstWhere((e) => e.index == map['LogType']),
      msg: map['Msg'],
    );
  }

  Map<String, dynamic> toJson() {
    final map = Map<String, dynamic>();
    map['LogType'] = logType.index;
    if (msg != null) {
      map['Msg'] = msg;
    }
    return map;
  }
}
