import 'package:fis_common/js_plateform/js_platform.dart';
import 'package:fis_common/logger/logger.dart';
import 'package:flyinsonolite/jsplatform/methodhandlerbase.dart';
import 'package:flyinsonolite/jsplatform/targetmethodname.dart';

class JsPlatformListener {
  final Map<TargetMethodName, MethodHandlerBase> _handlers = {};

  JsPlatformListener() {
    _init();
  }

  void run() {
    JSPlateForm.setJsPlatForm(_handleMessage);
  }

  void _init() {}

  void _handleMessage(String method, String arguments) {
    try {
      final enumIdx = int.parse(method);
      final enumVal = TargetMethodName.values[enumIdx];
      if (!_handlers.containsKey(enumVal)) {
        return;
      }
      final args = arguments.split('&');
      _handlers[enumVal]!.execute(args);
    } catch (e) {
      logger.e(
        "[PlatformListener] handle message error: method-$method not found.",
        e,
      );
    }
  }

  void _register<T extends MethodHandlerBase>(T handler) {
    _handlers[handler.methodName] = handler;
  }
}
