import 'package:fis_i18n/types.dart';

/// 通用模块
class FISCommonModule extends ModuleBase {
  FISCommonModule._(
      {required this.pleaseConnectVCloudFirst,
      required this.minimize,
      required this.exitOrHideTips,
      required this.accountHasNoPermission,
      required this.reset,
      required this.createApplication,
      required this.appointmentConsultation,
      required this.iApplied,
      required this.iOrganized,
      required this.iInvolved,
      required this.remeberPwd,
      required this.consultationDetail,
      required this.consultationImage,
      required this.consultationReport,
      required this.consultationFollowUp,
      required this.keyword,
      required this.chooseconsultationInstitutionfirst,
      required this.consultationInstitutionlistisempty,
      required this.competentExperts,
      required this.consultationDescription,
      required this.expertListIsEmpty,
      required this.theCurrentPasswordHasExpired,
      required this.currentConsultationNotSupport});

  static const ModuleName = "common";

  factory FISCommonModule(Map<String, dynamic> map) {
    return FISCommonModule._(
        pleaseConnectVCloudFirst: map.pick("pleaseConnectVCloudFirst"),
        minimize: map.pick("minimize"),
        exitOrHideTips: map.pick("exitOrHideTips"),
        accountHasNoPermission: map.pick("accountHasNoPermission"),
        reset: map.pick("reset"),
        createApplication: map.pick("createApplication"),
        appointmentConsultation: map.pick("appointmentConsultation"),
        iApplied: map.pick("iApplied"),
        iOrganized: map.pick("iOrganized"),
        iInvolved: map.pick("iInvolved"),
        remeberPwd: map.pick("remeberPwd"),
        consultationDetail: map.pick("consultationDetail"),
        consultationImage: map.pick("consultationImage"),
        consultationReport: map.pick("consultationReport"),
        consultationFollowUp: map.pick("consultationFollowUp"),
        keyword: map.pick("keyword"),
        chooseconsultationInstitutionfirst:
            map.pick("chooseconsultationInstitutionfirst"),
        consultationInstitutionlistisempty:
            map.pick("consultationInstitutionlistisempty"),
        competentExperts: map.pick("competentExperts"),
        consultationDescription: map.pick("consultationDescription"),
        expertListIsEmpty: map.pick("expertListIsEmpty"),
        theCurrentPasswordHasExpired: map.pick("theCurrentPasswordHasExpired"),
        currentConsultationNotSupport:
            map.pick("currentConsultationNotSupport"));
  }

  /// 请先连接设备云服务！
  final FTrStr pleaseConnectVCloudFirst;

  ///最小化
  final FTrStr minimize;

  ///您是想关闭杏聆荟页面还是最小化？
  final FTrStr exitOrHideTips;

  ///当前账号无权限
  final FTrStr accountHasNoPermission;

  /// 重置
  final FTrStr reset;

  ///创建申请
  final FTrStr createApplication;

  ///预约会诊
  final FTrStr appointmentConsultation;

  ///我申请的
  final FTrStr iApplied;

  ///我组织的
  final FTrStr iOrganized;

  ///我参与的
  final FTrStr iInvolved;

  ///记住密码
  final FTrStr remeberPwd;

  ///会诊详情
  final FTrStr consultationDetail;

  ///会诊图像
  final FTrStr consultationImage;

  ///会诊报告
  final FTrStr consultationReport;

  ///会诊随访
  final FTrStr consultationFollowUp;

  ///关键字
  final FTrStr keyword;

  ///请先选择会诊医院
  final FTrStr chooseconsultationInstitutionfirst;

  ///会诊医院列表为空
  final FTrStr consultationInstitutionlistisempty;

  ///会诊专家
  final FTrStr competentExperts;

  ///会诊详情
  final FTrStr consultationDescription;

  ///专家列表为空
  final FTrStr expertListIsEmpty;

  ///密码已过期
  final FTrStr theCurrentPasswordHasExpired;

  ///当前会诊不支持
  final FTrStr currentConsultationNotSupport;

  @override
  getProp(String propName) {
    // TODO: implement getProp
    throw UnimplementedError();
  }
}
