import 'dart:ui';

import 'package:fis_i18n/i18n.dart';
import 'package:flyinsonolite/localization/fis_i18n.dart';
import 'package:flyinsonolite/infrastructure/storage.dart';
import 'package:get/get.dart';

class Localization {
  static Future intializeAsync() async {
    Locale curLocale = CHINESE_LOCALE;

    var bookOptions = [
      FTrKeybookOption.ChineseOption,
      FTrKeybookOption.EnglishOption,
    ];

    await FI18n.init((locale) => Get.updateLocale(locale), bookOptions);
    await FI18n.load(curLocale);
    var fisBookOptions = [
      FISTrKeybookOption.ChineseOption,
      FISTrKeybookOption.EnglishOption,
    ];
    await FISI18n.init((locale) => Get.updateLocale(locale), fisBookOptions);
    await FISI18n.load(curLocale);
    Get.put(FI18n.ins);
    Get.put(FISI18n.ins);
  }
}

String getLanguageValues(
  String module,
  String code,
) {
  try {
    var value = Storage.configurationFromerver?.languageServerConfig
        .findLanguageValueByCode(module, code);
    return value ?? code;
  } catch (e) {
    //print(e);
  }
  return code;
}
