import 'dart:async';
import 'package:fis_i18n/i18n.dart';
import 'package:get/get.dart';

class VerificationCodeFieldController extends GetxController {
  var btnText = i18nBook.auth.sendVerificationCode.t.obs;
  var isBtnEnabled = true.obs;
  final int _countDown = 60;
  var _seconds = 0;
  Timer? _timer;

  /// 开启倒计时
  startCountDown() {
    isBtnEnabled.value = false;
    _seconds = _countDown;
    btnText.value =
        i18nBook.auth.sendVerificationCodeTimer.translate([_seconds]);
    _timer = Timer.periodic(const Duration(seconds: 1), (timer) {
      _seconds--;
      btnText.value =
          i18nBook.auth.sendVerificationCodeTimer.translate([_seconds]);
      if (_seconds == 0) {
        btnText.value = i18nBook.auth.resendVerificationCode.t;
        isBtnEnabled.value = true;
        timer.cancel();
      }
    });
  }

  @override
  void onClose() {
    _timer?.cancel();
    _timer = null;
    super.onClose();
  }
}
