import 'package:fis_jsonrpc/rpc.dart';
import 'package:flyinsonolite/jsonrpc/fisLib/services/log.m.dart';
import 'package:flyinsonolite/jsonrpc/jsonrpcclient.dart';
import 'package:flyinsonolite/infrastructure/logger.dart';
import 'package:flyinsonolite/login/models/heartbeat.dart';

/// 登录心跳
class LoginHeartbeat extends Heartbeat {
  LoginHeartbeat({
    required this.token,
    required int interval,
  }) : super(interval);

  /// 登录令牌
  final String token;

  @override
  void sendOnce() async {
    try {
      final result =
          await jsonRpcProxy.user.heartRateAsync(TokenRequest(token: token));
      await loggerAsyn(FISDeviceLogCategory.Info,
          "[Heartbeat] Send Login heartbeat, result: $result.");
    } catch (e) {
      await loggerAsyn(FISDeviceLogCategory.Error,
          '[Heartbeat] Send Login heartbeat error: $e');
    }
  }
}
