import 'package:fis_jsonrpc/services/device.m.dart';
import 'package:flyinsonolite/jsonrpc/fisLib/services/log.m.dart';
import 'package:flyinsonolite/jsonrpc/jsonrpcclient.dart';
import 'package:flyinsonolite/infrastructure/logger.dart';
import 'package:flyinsonolite/managers/basemanager.dart';
import 'package:flyinsonolite/managers/interfaces/idevicemanager.dart';

class DeviceManager extends BaseManager implements IDeviceManager {
  ///获取设备信息
  /// [deviceCode] 设备编号
  @override
  Future<DeviceExtendInfoDTO?> getDeviceInfoAsync(String deviceCode) async {
    try {
      return await jsonRpcProxy.device.getDeviceInfoAsync(
        GetDeviceRequest(
          token: token,
          deviceCode: deviceCode,
        ),
      );
    } catch (e) {
      await loggerAsyn(FISDeviceLogCategory.Error,
          "DeviceManager getDeviceInfoAsync error $e.");
    }
    return null;
  }
}
