import 'package:fis_jsonrpc/rpc.dart';
import 'package:flyinsonolite/jsonrpc/fisLib/services/log.m.dart';
import 'package:flyinsonolite/infrastructure/logger.dart';
import 'package:flyinsonolite/notifications/handlers/acceptliveconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/applyconsultationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/approvalapplyconsultationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/cancelinvitinginliveconsultationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/cancelinvitinginlivecoursenotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/cancelliveconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/changeconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/closeLiveconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/closeconsultationduetochangenotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/consultationRemindnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/consultationanswertimeouthandler.dart';
import 'package:flyinsonolite/notifications/handlers/emergencycallfailednotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/emergencycallnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/heartRatejoinconsultationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/heartrateleaveconsultationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/inviteapproveapplyconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/inviteconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/inviterejectnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/inviteinliveconsultationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/inviteliveconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/joininliveconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/joinliveconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/leaveconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/muteliveconsultationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/networkerrconsultationnotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/rejectapplaynotificationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/rejectinviteliveconsultationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/rejectliveconsultationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/sendinteractiveboarddatahandler.dart';
import 'package:flyinsonolite/notifications/handlers/switchvideoplayconsultationhandler.dart';
import 'package:flyinsonolite/notifications/handlers/tokenreplacedhandler.dart';
import 'package:flyinsonolite/notifications/handlers/uploadconsultationdatahandler.dart';
import 'package:get/get.dart';

final _instance = _buildInstance();

WsNotificationCenter get notificationCenter => _instance;

WsNotificationCenter _buildInstance() {
  final instance = WsNotificationCenter();
  // 注册消息处理器
  instance.register(
      Get.put(SendInteractiveBoardDataHandler())); // 白板 | 1 | 互动白板数据通知
  instance.register(Get.put(TokenReplacedNotificationHandler()));
  instance.register(Get.put(
      CancelInvitingInLiveConsultationHandler())); // 7 |  取消会诊过程中邀请成员的通知
  instance
      .register(Get.put(InviteInLiveConsultationHandler())); // 8 |会诊过程中邀请成员的通知
  instance.register(
      Get.put(InviteLiveConsultationNotificationHandler())); //11 | 开始会诊的通知
  instance.register(
      Get.put(AcceptLiveConsultationNotificationHandler())); //12 | 接受会诊的通知
  instance.register(Get.put(RejectLiveConsultationHandler())); //13 | 拒绝会诊通知
  instance
      .register(Get.put(RejectInviteLiveConsultationHandler())); //21 | 拒绝会诊通知
  instance.register(
      Get.put(CancelLiveConsultationNotificationHandler())); // 15 | 取消会诊通知
  instance.register(
      Get.put(CloseLiveConsultationNotificationHandler())); // 16 | 关闭会诊通知
  instance.register(
      Get.put(JoinLiveConsultationNotificationHandler())); // 17 | 进入会诊通知
  instance.register(
      Get.put(NetworkErrConsultationNotificationHandler())); // 18 | 网络质量不佳的通知
  instance
      .register(Get.put(LeaveConsultationNotificationHandler())); // 19 离开会诊通知
  instance.register(
      Get.put(JoinInLiveConsultationNotificationHandler())); // 20 会诊中其他成员加入房间通知
  instance.register(Get.put(MuteLiveConsultationHandler())); // 27 成员静音通知
  instance.register(
      Get.put(SwitchVideoPlayConsultationHandler())); // 28 成员摄像头开启或关闭通知
  instance
      .register(Get.put(HeartRateJoinConsultationHandler())); // 29 成员心跳进入会诊间
  instance.register(Get.put(EmergencyCallNotificationHandler())); //37 急诊呼叫专家通知
  instance.register(
      Get.put(EmergencyCallFailedNotificationHandler())); //38 急诊呼叫失败通知
  instance.register(Get.put(HeartRateLeaveConsultationHandler())); //30 成员离开通知
  instance
      .register(Get.put(ChangeConsultationNotificationHandler())); //52 切换会诊房间
  instance.register(
      Get.put(CloseConsultationDueToChangeNotificationHandler())); //55 关闭会诊房间
  instance.register(
      Get.put(RejectApplayNotificationHandler())); // 📅| 6 | 拒绝预约申请的通知
  instance.register(
      Get.put(ConsultationRemindNotificationHandler())); // 📅| 9 | 会诊开始前提醒的通知
  instance.register(Get.put(ApplyConsultationHandler())); // 📅| 22 | 会诊申请通知
  instance.register(
      Get.put(ApprovalApplyConsultationHandler())); // 📅| 23 | 批准申请会诊通知
  instance.register(
      Get.put(InviteConsultationNotificationHandler())); // 📅| 24 | 会诊受邀请人通知
  instance.register(Get.put(
      InviteApproveApplyConsultationNotificationHandler())); // 📅| 25 | 会诊受邀请参与人同意通知
  instance.register(
      Get.put(InviteRejectNotificationHandler())); // 📅| 26 | 会诊受邀请参与人拒绝通知
  //课程相关通知
  instance.register(Get.put(
      CancelInvitingInLiveCourseNotificationHandler())); // 68 取消呼叫 to 客户端

  instance.register(Get.put(UploadConsultationDataHandler())); // 103 会诊截图通知

  instance
      .register(Get.put(ConsultationAnswerTimeoutHandler())); // 100 | 超时未接听通知
  _runDistributeDemo();
  return instance;
}

void _runDistributeDemo() {
  Future.delayed(
    const Duration(milliseconds: 100),
    () {
      final handler = Get.find<TokenReplacedNotificationHandler>();
      void onSub01(TokenReplacedNotification message) {
        loggerAsyn(FISDeviceLogCategory.Info,
            "Sub01 - Receive msg at ${DateTime.now()}");
      }

      void onSub02(TokenReplacedNotification message) {
        loggerAsyn(FISDeviceLogCategory.Info,
            "Sub02 - Receive msg at ${DateTime.now()}");
        Future.delayed(const Duration(milliseconds: 100), () {
          handler.unsubscribe(onSub02);
        });
      }

      handler.subscribe(onSub01);
      handler.subscribe(onSub02);
    },
  );
}
