import 'package:fis_jsonrpc/rpc.dart';
import 'package:get/get_utils/get_utils.dart';

class PatientDataService {
  /// 获取病人数据
  static Map<String, String> getPatientValue(List<DataItemDTO>? patientData) {
    if (patientData == null) {
      return {};
    }

    return {
      'Name': _handlePatientValue(patientData, 'Name'),
      'Age': _handlePatientValue(patientData, 'Age'),
      'Sex': _handlePatientValue(patientData, 'Sex'),
      'Phone': _handlePatientValue(patientData, 'Phone'),
      'Birthday': _handlePatientValue(patientData, 'Birthday'),
      'AgeYear': _handlePatientValue(patientData, 'AgeYear'),
      'AgeMonth': _handlePatientValue(patientData, 'AgeMonth'),
      'AgeWeek': _handlePatientValue(patientData, 'AgeWeek'),
      'AgeDay': _handlePatientValue(patientData, 'AgeDay'),
      'AgeUnits': _handlePatientValue(patientData, 'AgeUnits'),
      'Anamnesis': _handlePatientValue(patientData, 'Anamnesis'),
      'HeadImgUrl': _handlePatientValue(patientData, 'HeadImgUrl'),
      'AnimalInfoName': _handlePatientValue(patientData, 'AnimalInfoName'),
      "IdentityCard": _handlePatientValue(patientData, 'IdentityCard'),
      'InsuranceCode': _handlePatientValue(patientData, 'InsuranceCode'),
      'Species': _handlePatientValue(patientData, 'Species'),
      "Breed": _handlePatientValue(patientData, 'Breed'),
    };
  }

  /// 处理病人参数
  static String _handlePatientValue(
      List<DataItemDTO> patientData, String value) {
    return patientData
            .firstWhereOrNull(
              (element) => element.key == value,
            )
            ?.value ??
        '';
  }
}
