import 'package:flutter/material.dart';

class CustomThemeData {
  String themeName;
  String? fontFamily;
  ThemeData themeData;
  LoginContainStyle loginContainStyle;
  ElevatedButtonLinearGradientStyle elevatedButtonLinearGradientStyle;
  FISSquareIconButtonStyle squareIconButtonStyle;
  Color iconButtonIconColor;
  DropdownButtonStyle dropdownButtonStyle;
  Color bgContainerColor;
  DialogStyle dialogStyle;
  FISLabelInputFieldStyle fisLabelInputFieldStyle;
  Color homepageHeaderColor;
  ListViewStyle listViewStyle;
  Color videoLoadingColor;
  DatePickerStyle datePickerStyle;
  ListViewButtonItemStyle listViewButtonItemStyle;
  TextStyle titleTextStyle;
  TextStyle normalTextStyle;
  CustomThemeData(
      this.themeName,
      this.fontFamily,
      this.themeData,
      this.loginContainStyle,
      this.elevatedButtonLinearGradientStyle,
      this.squareIconButtonStyle,
      this.iconButtonIconColor,
      this.dropdownButtonStyle,
      this.bgContainerColor,
      this.dialogStyle,
      this.fisLabelInputFieldStyle,
      this.homepageHeaderColor,
      this.listViewStyle,
      this.videoLoadingColor,
      this.datePickerStyle,
      this.listViewButtonItemStyle,
      this.titleTextStyle,
      this.normalTextStyle);
}

class DatePickerStyle {
  Color leftSizeColor;
  Color backgroundColor;
  DatePickerStyle(this.leftSizeColor, this.backgroundColor);
}

class LoginContainStyle {
  Color backgroundColor;
  Color borderColor;
  LoginContainStyle(this.backgroundColor, this.borderColor);
}

class ElevatedButtonLinearGradientStyle {
  LinearGradient elevatedButtonLinearGradient;
  Color textColor;
  ElevatedButtonLinearGradientStyle(
      this.elevatedButtonLinearGradient, this.textColor);
}

class FISSquareIconButtonStyle {
  Color textColor;
  Color iconColor;
  LinearGradient backgroundGradient;
  LinearGradient focusedLinearGradient;
  FISSquareIconButtonStyle(this.textColor, this.iconColor,
      this.focusedLinearGradient, this.backgroundGradient);
}

class ElevatedButtonStyle {
  Color backgroundColor;
  Color pressedColor;
  ElevatedButtonStyle(this.backgroundColor, this.pressedColor);
}

class DropdownButtonStyle {
  Color iconColor;
  double iconSize;
  Color dropdownColor;

  DropdownButtonStyle(this.iconColor, this.iconSize, this.dropdownColor);
}

class ListViewStyle {
  Color itembgColor;
  Color selecteLeftBorderColodr;
  Color hoverColor;
  ListViewStyle(
      this.itembgColor, this.selecteLeftBorderColodr, this.hoverColor);
}

class DialogStyle {
  Color headerColor;
  TextStyle titleTextStyle;
  LinearGradient backgroundGradient;
  TextStyle messageTextStyle;
  Gradient buttonGradient;
  DialogStyle(this.headerColor, this.titleTextStyle, this.backgroundGradient,
      this.messageTextStyle, this.buttonGradient);
}

class FISLabelInputFieldStyle {
  TextStyle labelTextStyle;
  TextStyle inputTextStyle;
  Color? fillColor;
  Color inputTextBorderColor;
  FISLabelInputFieldStyle(this.labelTextStyle, this.inputTextStyle,
      this.fillColor, this.inputTextBorderColor);
}

class ListViewButtonItemStyle {
  LinearGradient normalGradient;
  LinearGradient selectedGradient;
  Color selectedTextColor;
  ListViewButtonItemStyle(
      this.normalGradient, this.selectedGradient, this.selectedTextColor);
}
